///////////////////////////////////
//Technik 2009
//Revolution Engine 0.5
///////////////////////////////////
//Main Header file
#ifndef REV_MAIN_H
#define REV_MAIN_H

//External header files
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <math.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include <pngu.h>
#include <time.h>
#include <ogc/lwp_watchdog.h>
#include <sys/dir.h>
#include <sys/statvfs.h>
#include <unistd.h>
#include <ft2build.h>
#include FT_FREETYPE_H

//Revolution engine header files
#include "REVUtils.h"
#include "REVConfig.h"
#include "REVMaths.h"
#include "REVTime.h"
#include "REVNodes.h"
#include "REVLights.h"
#include "REVMaterials.h"
#include "REVScreen.h"
#include "REVFonts.h"
#include "REVModels.h"
#include "REVMd5.h"
#include "REVObjects.h"
#include "REVCameras.h"
#include "REVSkybox.h"
#include "REVViewports.h"

//Data types, classes and structures
void setBGColor(GXColor clr);

class ROOT
{
public:
	SKYBOX skyBox;
	VIEWPORT * views;
	ROOT();
	void init(f32 w, f32 h);
private:
	NODE * rootNode;
	N2D * rootN2D;
	LIGHT * fstLight;
	HTCAMERA * fstHTC;
	BUTTON * fstBtn;
friend class NODE;
friend class N2D;
friend class HTCAMERA;
friend class LIGHT;
friend class AMODEL;//Temporary
friend class SMODEL;//Temporary
friend class VIEWPORT;
friend class BUTTON;
friend void REV_preProcess(void);
friend void REV_process(void);
friend void update2D(void);
};
//Global data
extern ROOT * mainRoot;
extern WPADData * wmData[4];
extern GXRModeObj *rMode;

//Public functions
void REV_init();
void REV_preProcess();
void REV_process();
void REV_exit();

//Private functions

#endif
