///////////////////////////////////
//Technik 2009 - 2010
//Revolution Engine 0.5
///////////////////////////////////

//Header files
#include "REV.h"//Just one header file to include

#define STR_BUFFER_SIZE 256

//This function is the action we assign to the button on click

int main()
{
	REV_init();//One function inits everything (WPAD, PAD included)
	//Now comes custom application init code
	SMODEL * buggyMd = new SMODEL("RevExamples/models/buggy.rms", FF_RMS);
	buggyMd->scale(2/buggyMd->getCenter().z);
	SMODEL * floorMd = new SMODEL("RevExamples/models/plane.rms", FF_RMS);
	floorMd->scale(vector3(40.0f, 40.0f, 1.0f));
	DLIGHT * l1 = new DLIGHT();
	ambientLight = rgb(80,80,80);
	l1->setPos(vector3(2.0f, 0.3f,-1.0f));
	defaultCam->setPos(vector3(0.0f, -15.0f, 4.0f));
	defaultCam->rotate(AXIS_X, -15);
	OBJECT * floor = new OBJECT(floorMd);
	BMATERIAL * sandMt = new BMATERIAL(SC_WHITE, SC_BLACK);//No specular reflections in the floor
	sandMt->diffuseMap = loadPng("RevExamples/maps/sand.png");
	floor->material = sandMt;
	mainRoot->views->setSize(320, 240);
	VIEWPORT * v1 = new VIEWPORT(vector3(320,0, 10),320,240);//Uses default camera
	CAMERA * c1 = new CAMERA();
	VIEWPORT * v2 = new VIEWPORT(vector3(0,240, 1),640,240, c1);//Uses c1 camera
	c1->rotate(AXIS_Z, 15);
	c1->move(vector3(0.0f, -22.0f, 2.5f), RT_SELF);
	OBJECT * buggy = new OBJECT(buggyMd);
	buggy->rotate(AXIS_Z, 90);
	BMATERIAL * buggyM = new BMATERIAL(SC_WHITE, SC_WHITE, 2.2f);
	buggyM->diffuseMap = loadPng("RevExamples/maps/buggy.png");
	buggy->material = buggyM;
	NODE * aux = new NODE();
	buggy->addChild(aux);
	defaultCam->attach(aux);
	//Main Loop
	while(1)
	{
		//Before every frame
		REV_preProcess();
		//If someone pressed home, exit
		if(WPAD_ButtonsDown(0) & WPAD_BUTTON_HOME)
		REV_exit();
		//frame, here goes your loop code
		aux->rotate(AXIS_Z, 30*gameTime);
		//After every frame
		REV_process();
	}
}

